import React, { HTMLAttributes } from 'react';
import './CIcon.css';
export interface CIconSvgProps extends Omit<HTMLAttributes<SVGSVGElement>, 'content'> {
    /**
     * A string of all className you want applied to the component.
     */
    className?: string;
    /**
     * Use for replacing default CIcon component classes. Prop is overriding the 'size' prop.
     */
    customClassName?: string | string[];
    /**
     * The height attribute defines the vertical length of an icon.
     */
    height?: number;
    /**
     * Size of the icon. Available sizes: 'sm', 'lg', 'xl', 'xxl', '3xl...9xl', 'custom', 'custom-size'.
     */
    size?: 'custom' | 'custom-size' | 'sm' | 'lg' | 'xl' | 'xxl' | '3xl' | '4xl' | '5xl' | '6xl' | '7xl' | '8xl' | '9xl';
    /**
     * Title tag content.
     */
    title?: string;
    /**
     * The width attribute defines the horizontal length of an icon.
     */
    width?: number;
}
export declare const CIconSvg: React.ForwardRefExoticComponent<CIconSvgProps & React.RefAttributes<SVGSVGElement>>;
